SXADM-CLUSTER(8)

NAME
sxadm-cluster - manage SX clusters

SYNOPSIS
sxadm cluster [OPTIONS] <MODE> [NODE1 [NODE2...]] sx://[profile@]cluster
where NODE is a string in the form <CAPACITY>/<ADDRESS>[/INTERNAL_ADDRESS][/UUID], describing a node in a cluster (used for options, which operate on a list of nodes).

DESCRIPTION
sxadm cluster is used to create and maintain remote clusters. In contrast to sxadm node, all operations are performed over the network, therefore it requires a valid admin access to the cluster.

OPTIONS

-h, --help
    Print help and exit

--full-help
    Print help, including hidden options, and exit

-V, --version
    Print version and exit

  Operation modes:

-N, --new
    Create a new SX cluster with a local node. This command is only used when creating the cluster and requires specification of the first node joining the cluster. If a UUID is not provided in the NODE's string, it will be automatically assigned. The subsequent nodes get joined to the cluster with --modify.

-I, --info
    Shows configuration of the cluster, its list of nodes and current operations.

-M, --modify
    Modify an existing SX cluster. This option allows adding, removing and resizing nodes. It operates on a list of nodes - the current list can be obtained with --info.

-l, --list-nodes
    Show current status of all nodes. This includes disk usage, memory usage, software version, and others.

-L, --lock
    This option applies an advisory lock and should be performed before making changes to the cluster.

-U, --unlock
    This option removes an advisory lock.

-R, --resize=<+/->SIZE
    This option can proportionally grow or shrink the entire cluster, resizing each individual node with respect to its size. For example, growing a cluster made of three nodes: A(1TB), B(1TB), C(2TB) by 4TB will results in new node sizes: A(2TB), B(2TB), C(4TB). The benefit of using this option is a minimized relocation of data across the cluster. The nodes can be also resized individually with --modify.

-F, --replace-faulty
    Replace faulty nodes in a cluster. This option takes pairs of faulty node - replacement node, where the replacement node should provide the same capacity as the faulty one. The replace process assumes all data on the faulty node has been lost and will attempt to recover it from the other nodes in the cluster.

-S, --set-faulty
    This option marks selected nodes as faulty, which will no longer be used by the clients. They can be later replaced with --replace-faulty.

-G, --force-gc
    Force a garbage collection cycle on all nodes.

-X, --force-expire
    Force GC and expiration of reservations on all nodes.

--get-cluster-key
    Obtain remote cluster key.

--get-allowed-replica
    Obtain the minimum and maximum volume replica count currently allowed on the cluster. The replica values depend on a few factors, such as number of nodes, zone configuration and the state of the cluster.

-m, --set-mode=MODE
    Set cluster operating mode ('ro' or 'rw' for read-only or write-only respectively). The read-only mode can be used to perform cluster maintainance (eg. perform sxadm node --check).

--upgrade
    Perform sanity checks on all nodes in the cluster. Start a cluster upgrade if no problems are found, followed by a garbage collection.

--set-meta="KEY=VALUE"
    Set cluster metadata in a form of a key-value pair. The metadata can only be set by a cluster administrator, but can be obtained by all users.

--get-meta=KEY
    Display a specific entry from the cluster metadata. When the key is ALL, then all entries will get displayed.

--delete-meta=KEY
    Delete a specific entry from the cluster metadata.

--set-param="KEY=VALUE"
    Set a cluster parameter in a form of a key-value pair. The cluster settings can only be changed by an administrator.

--get-param=KEY
    Get a value of a specific cluster parameter. When the key is ALL, then all cluster settings will be displayed. The cluster settings can only be accessed by an administrator.

  New cluster options:

-d, --node-dir=PATH
    Path to the node directory.

--port=INT
    Set the cluster destination TCP port (default 443 in secure mode or 80 in insecure mode).

--ssl-ca-file=PATH
    SSL CA certificate file of the SX cluster (same file as in httpd configuration).

-k, --admin-key=PATH
    File containing a pre-generated admin authentication token or stdin if "-" is given (default autogenerate token).

  Common options:

-b, --batch-mode
    Turn off interactive confirmations and assume yes for all questions.

-H, --human-readable
    Print human readable sizes (default=off)

-D, --debug
    Enable debug messages (default=off)

-c, --config-dir=PATH
    Path to SX configuration directory

  Cluster locking options:

--locking-node=ADDRESS
    IP address of a node used to aqcuire a cluster lock. By default a random node will be selected and the lock will be spread across the cluster.

FURTHER DOCUMENTATION
Full documentation with additional examples available at: <http://www.skylable.com/docs/>

SEE ALSO
sxadm(8), sxadm-node(8), sx.fcgi(8)